/*
 *  Copyright (c) 2021 Rockchip Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef ___RK_AIQ_UAPITYPES_H__
#define ___RK_AIQ_UAPITYPES_H__

#include "rk_aiq_user_api_common.h"
#include "aec_uapi_head.h"
#include "awb_uapi_head.h"
#include "amerge_uapi_head.h"
#include "atmo_uapi_head.h"
#include "adrc_uapi_head.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef struct __ae_uapi {
  // M4_STRUCT_DESC("expsw_attr", "normal_ui_style")
  uapi_expsw_attr_t expsw_attr;
  // M4_STRUCT_DESC("QueryExpInfo", "normal_ui_style")
  uapi_expinfo_t expinfo;
} ae_uapi_t;

typedef struct __awb_uapi {
  // M4_STRUCT_DESC("mode", "normal_ui_style")
  uapi_wb_mode_t mode;
  // M4_STRUCT_DESC("wbgain", "normal_ui_style")
  uapi_wb_gain_t wbgain;
} awb_uapi_t;

typedef struct __amerge_uapi {
  // M4_STRUCT_DESC("ctldata", "normal_ui_style")
  uapiMergeCurrCtlData_t ctldata;
} amerge_uapi_t;

typedef struct __atmo_uapi {
  // M4_STRUCT_DESC("ctldata", "normal_ui_style")
  uapiTmoCurrCtlData_t ctldata;
} atmo_uapi_t;

typedef struct __adrc_uapi {
  // M4_STRUCT_DESC("drc", "normal_ui_style")
  drcAttr_t drc;
} adrc_uapi_t;

typedef struct __aiq_scene {
  // M4_STRING_DESC("main_scene", M4_SIZE(1,1), M4_RANGE(0, 32), "normal", M4_DYNAMIC(0))
  char* main_scene;
  // M4_STRING_DESC("sub_scene", M4_SIZE(1,1), M4_RANGE(0, 32), "day", M4_DYNAMIC(0))
  char* sub_scene;
} aiq_scene_t;

typedef struct __work_mode {
  // M4_ENUM_DESC("mode", "rk_aiq_working_mode_t", "RK_AIQ_WORKING_MODE_NORMAL");
  rk_aiq_working_mode_t mode;
} work_mode_t;

typedef struct __aiq_sysctl_desc {
  // M4_STRUCT_DESC("scene", "normal_ui_style")
  aiq_scene_t scene;
  // M4_STRUCT_DESC("work_mode", "normal_ui_style")
  work_mode_t work_mode;
} RkaiqSysCtl_t;

typedef struct __aiq_uapi_t {
  // M4_STRUCT_DESC("ae_uapi", "normal_ui_style")
  ae_uapi_t ae_uapi;
  // M4_STRUCT_DESC("awb_uapi", "normal_ui_style")
  awb_uapi_t awb_uapi;
  // M4_STRUCT_DESC("amerge_uapi", "normal_ui_style")
  amerge_uapi_t amerge_uapi;
  // M4_STRUCT_DESC("atmo_uapi", "normal_ui_style")
  atmo_uapi_t atmo_uapi;
  // M4_STRUCT_DESC("adrc_uapi", "normal_ui_style")
  adrc_uapi_t adrc_uapi;
  // M4_STRUCT_DESC("SystemCtl", "normal_ui_style")
  RkaiqSysCtl_t system;
} RkaiqUapi_t;

#ifdef __cplusplus
}
#endif

#endif  /*___RK_AIQ_UAPITYPES_H__*/
